From: "Luis R. Rodriguez" <mcgrof@kernel.org>
To: gregkh@linuxfoundation.org
Cc: mfuzzey@parkeon.com, ebiederm@xmission.com,
dmitry.torokhov@gmail.com, wagi@monom.org, dwmw2@infradead.org,
jewalt@lgsinnovations.com, rafal@milecki.pl,
arend.vanspriel@broadcom.com, rjw@rjwysocki.net,
yi1.li@linux.intel.com, atull@kernel.org,
moritz.fischer@ettus.com, pmladek@suse.com,
johannes.berg@intel.com, emmanuel.grumbach@intel.com,
luciano.coelho@intel.com, kvalo@codeaurora.org, luto@kernel.org,
torvalds@linux-foundation.org, keescook@chromium.org,
takahiro.akashi@linaro.org, dhowells@redhat.com,
pjones@redhat.com, hdegoede@redhat.com, alan@linux.intel.com,
tytso@mit.edu, mtk.manpages@gmail.com,
paul.gortmaker@windriver.com, mtosatti@redhat.com,
mawilcox@microsoft.com, linux-api@vger.kernel.org,
linux-fsdevel@vger.kernel.org, linux-kernel@vger.kernel.org, L
Subject: [PATCH 1/4] test_firmware: add test case for SIGCHLD on sync fallback
Date: Wed, 14 Jun 2017 15:20:14 -0700 [thread overview]
Message-ID: <20170614222017.14653-2-mcgrof@kernel.org> (raw)
In-Reply-To: <20170614222017.14653-1-mcgrof@kernel.org>
It has been reported that SIGCHLD will trigger an immediate abort
on sync firmware requests which rely on the sysfs interface for a
trigger. This is unexpected behaviour, this reproduces this issue.
This test case currenty fails.
Reported-by: Martin Fuzzey <mfuzzey@parkeon.com>
Signed-off-by: Luis R. Rodriguez <mcgrof@kernel.org>
---
tools/testing/selftests/firmware/fw_fallback.sh | 31 +++++++++++++++++++++++++
1 file changed, 31 insertions(+)
diff --git a/tools/testing/selftests/firmware/fw_fallback.sh b/tools/testing/selftests/firmware/fw_fallback.sh
index 2e4c22d5abf7..8f511035f783 100755
--- a/tools/testing/selftests/firmware/fw_fallback.sh
+++ b/tools/testing/selftests/firmware/fw_fallback.sh
@@ -134,6 +134,27 @@ load_fw_custom_cancel()
wait
}
+load_fw_fallback_with_child()
+{
+ local name="$1"
+ local file="$2"
+
+ # This is the value already set but we want to be explicit
+ echo 4 >/sys/class/firmware/timeout
+
+ sleep 1 &
+ SECONDS_BEFORE=$(date +%s)
+ echo -n "$name" >"$DIR"/trigger_request 2>/dev/null
+ SECONDS_AFTER=$(date +%s)
+ SECONDS_DELTA=$(($SECONDS_AFTER - $SECONDS_BEFORE))
+ if [ "$SECONDS_DELTA" -lt 4 ]; then
+ RET=1
+ else
+ RET=0
+ fi
+ wait
+ return $RET
+}
trap "test_finish" EXIT
@@ -221,4 +242,14 @@ else
echo "$0: cancelling custom fallback mechanism works"
fi
+set +e
+load_fw_fallback_with_child "nope-signal-$NAME" "$FW"
+if [ "$?" -eq 0 ]; then
+ echo "$0: SIGCHLD on sync ignored as expected" >&2
+else
+ echo "$0: error - sync firmware request cancelled due to SIGCHLD" >&2
+ exit 1
+fi
+set -e
+
exit 0
--
2.11.0
WARNING: multiple messages have this Message-ID (diff)
From: "Luis R. Rodriguez" <mcgrof@kernel.org>
To: gregkh@linuxfoundation.org
Cc: mfuzzey@parkeon.com, ebiederm@xmission.com,
dmitry.torokhov@gmail.com, wagi@monom.org, dwmw2@infradead.org,
jewalt@lgsinnovations.com, rafal@milecki.pl,
arend.vanspriel@broadcom.com, rjw@rjwysocki.net,
yi1.li@linux.intel.com, atull@kernel.org,
moritz.fischer@ettus.com, pmladek@suse.com,
johannes.berg@intel.com, emmanuel.grumbach@intel.com,
luciano.coelho@intel.com, kvalo@codeaurora.org, luto@kernel.org,
torvalds@linux-foundation.org, keescook@chromium.org,
takahiro.akashi@linaro.org, dhowells@redhat.com,
pjones@redhat.com, hdegoede@redhat.com, alan@linux.intel.com,
tytso@mit.edu, mtk.manpages@gmail.com,
paul.gortmaker@windriver.com, mtosatti@redhat.com,
mawilcox@microsoft.com, linux-api@vger.kernel.org,
linux-fsdevel@vger.kernel.org, linux-kernel@vger.kernel.org,
"Luis R. Rodriguez" <mcgrof@kernel.org>
Subject: [PATCH 1/4] test_firmware: add test case for SIGCHLD on sync fallback
Date: Wed, 14 Jun 2017 15:20:14 -0700 [thread overview]
Message-ID: <20170614222017.14653-2-mcgrof@kernel.org> (raw)
In-Reply-To: <20170614222017.14653-1-mcgrof@kernel.org>
It has been reported that SIGCHLD will trigger an immediate abort
on sync firmware requests which rely on the sysfs interface for a
trigger. This is unexpected behaviour, this reproduces this issue.
This test case currenty fails.
Reported-by: Martin Fuzzey <mfuzzey@parkeon.com>
Signed-off-by: Luis R. Rodriguez <mcgrof@kernel.org>
---
tools/testing/selftests/firmware/fw_fallback.sh | 31 +++++++++++++++++++++++++
1 file changed, 31 insertions(+)
diff --git a/tools/testing/selftests/firmware/fw_fallback.sh b/tools/testing/selftests/firmware/fw_fallback.sh
index 2e4c22d5abf7..8f511035f783 100755
--- a/tools/testing/selftests/firmware/fw_fallback.sh
+++ b/tools/testing/selftests/firmware/fw_fallback.sh
@@ -134,6 +134,27 @@ load_fw_custom_cancel()
wait
}
+load_fw_fallback_with_child()
+{
+ local name="$1"
+ local file="$2"
+
+ # This is the value already set but we want to be explicit
+ echo 4 >/sys/class/firmware/timeout
+
+ sleep 1 &
+ SECONDS_BEFORE=$(date +%s)
+ echo -n "$name" >"$DIR"/trigger_request 2>/dev/null
+ SECONDS_AFTER=$(date +%s)
+ SECONDS_DELTA=$(($SECONDS_AFTER - $SECONDS_BEFORE))
+ if [ "$SECONDS_DELTA" -lt 4 ]; then
+ RET=1
+ else
+ RET=0
+ fi
+ wait
+ return $RET
+}
trap "test_finish" EXIT
@@ -221,4 +242,14 @@ else
echo "$0: cancelling custom fallback mechanism works"
fi
+set +e
+load_fw_fallback_with_child "nope-signal-$NAME" "$FW"
+if [ "$?" -eq 0 ]; then
+ echo "$0: SIGCHLD on sync ignored as expected" >&2
+else
+ echo "$0: error - sync firmware request cancelled due to SIGCHLD" >&2
+ exit 1
+fi
+set -e
+
exit 0
--
2.11.0
next prev parent reply other threads:[~2017-06-14 22:20 UTC|newest]
Thread overview: 77+ messages / expand[flat|nested] mbox.gz Atom feed top
2017-06-14 22:20 [PATCH 0/4] firmware: fix fallback mechanism by ignoring SIGCHLD Luis R. Rodriguez
2017-06-14 22:20 ` Luis R. Rodriguez
2017-06-14 22:20 ` Luis R. Rodriguez [this message]
2017-06-14 22:20 ` [PATCH 1/4] test_firmware: add test case for SIGCHLD on sync fallback Luis R. Rodriguez
2017-06-14 22:20 ` [PATCH 2/4] swait: add the missing killable swaits Luis R. Rodriguez
2017-06-14 22:20 ` Luis R. Rodriguez
[not found] ` <20170614222017.14653-3-mcgrof-DgEjT+Ai2ygdnm+yROfE0A@public.gmane.org>
2017-06-29 12:54 ` Greg KH
2017-06-29 12:54 ` Greg KH
[not found] ` <20170629125402.GH26046-U8xfFu+wG4EAvxtiuMwx3w@public.gmane.org>
2017-06-29 13:05 ` Thomas Gleixner
2017-06-29 13:05 ` Thomas Gleixner
2017-06-29 13:35 ` Greg KH
2017-06-29 13:35 ` Greg KH
2017-06-29 13:46 ` Thomas Gleixner
2017-06-29 13:46 ` Thomas Gleixner
2017-06-29 16:13 ` Linus Torvalds
2017-06-29 16:13 ` Linus Torvalds
2017-06-29 16:31 ` Matthew Wilcox
2017-06-29 16:31 ` Matthew Wilcox
2017-06-29 17:29 ` Luis R. Rodriguez
2017-06-29 17:29 ` Luis R. Rodriguez
2017-06-29 17:40 ` Davidlohr Bueso
2017-06-29 17:40 ` Davidlohr Bueso
2017-06-29 17:57 ` Linus Torvalds
2017-06-29 17:57 ` Linus Torvalds
2017-06-29 18:33 ` Davidlohr Bueso
2017-06-29 18:33 ` Davidlohr Bueso
[not found] ` <20170629183339.GD3954-3dK4OQgjB4rH06JGZaSw0A@public.gmane.org>
2017-06-29 18:59 ` Linus Torvalds
2017-06-29 18:59 ` Linus Torvalds
[not found] ` <CA+55aFz8Mhx+A-g-5yOG-O1ZLRUR_fpeeA4iBNGH8EnDBZEdpA-JsoAwUIsXosN+BqQ9rBEUg@public.gmane.org>
2017-06-29 19:40 ` Luis R. Rodriguez
2017-06-29 19:40 ` Luis R. Rodriguez
2017-06-29 19:44 ` Luis R. Rodriguez
2017-06-29 19:44 ` Luis R. Rodriguez
[not found] ` <20170629194455.GR21846-B4tOwbsTzaBolqkO4TVVkw@public.gmane.org>
2017-06-29 20:58 ` Jakub Kicinski
2017-06-29 20:58 ` Jakub Kicinski
2017-06-29 22:50 ` Luis R. Rodriguez
2017-06-29 22:50 ` Luis R. Rodriguez
2017-06-29 22:53 ` Jakub Kicinski
2017-06-29 22:53 ` Jakub Kicinski
2017-06-29 23:00 ` Luis R. Rodriguez
2017-06-29 23:00 ` Luis R. Rodriguez
2017-06-29 23:06 ` Jakub Kicinski
2017-06-29 23:06 ` Jakub Kicinski
[not found] ` <20170629225003.GU21846-B4tOwbsTzaBolqkO4TVVkw@public.gmane.org>
2017-07-12 21:33 ` Luis R. Rodriguez
2017-07-12 21:33 ` Luis R. Rodriguez
[not found] ` <20170629194015.GQ21846-B4tOwbsTzaBolqkO4TVVkw@public.gmane.org>
2017-06-29 20:57 ` Linus Torvalds
2017-06-29 20:57 ` Linus Torvalds
2017-07-05 2:06 ` Davidlohr Bueso
2017-07-05 2:06 ` Davidlohr Bueso
[not found] ` <20170705020635.GD11168-3dK4OQgjB4rH06JGZaSw0A@public.gmane.org>
2017-07-07 19:58 ` Linus Torvalds
2017-07-07 19:58 ` Linus Torvalds
2017-07-07 22:27 ` Davidlohr Bueso
2017-07-07 22:27 ` Davidlohr Bueso
2017-07-07 22:48 ` Linus Torvalds
2017-07-07 22:48 ` Linus Torvalds
2017-06-29 19:15 ` Marcelo Tosatti
2017-06-29 19:15 ` Marcelo Tosatti
2017-06-29 19:15 ` Marcelo Tosatti
[not found] ` <20170629191506.GB12368-I4X2Mt4zSy4@public.gmane.org>
2017-06-30 4:03 ` Linus Torvalds
2017-06-30 4:03 ` Linus Torvalds
2017-06-30 11:55 ` Marcelo Tosatti
2017-06-30 11:55 ` Marcelo Tosatti
2017-06-30 11:55 ` Marcelo Tosatti
2017-06-30 11:57 ` Marcelo Tosatti
2017-06-30 11:57 ` Marcelo Tosatti
2017-06-30 17:30 ` Krister Johansen
2017-06-30 17:30 ` Krister Johansen
2017-06-14 22:20 ` [PATCH 3/4] firmware: avoid invalid fallback aborts by using killable swait Luis R. Rodriguez
2017-06-14 22:20 ` Luis R. Rodriguez
2017-06-14 22:20 ` [PATCH 4/4] firmware: send -EINTR on signal abort on fallback mechanism Luis R. Rodriguez
2017-06-14 22:20 ` Luis R. Rodriguez
2017-06-15 7:49 ` [PATCH 0/4] firmware: fix fallback mechanism by ignoring SIGCHLD Martin Fuzzey
[not found] ` <20170614222017.14653-1-mcgrof-DgEjT+Ai2ygdnm+yROfE0A@public.gmane.org>
2017-06-26 21:19 ` Luis R. Rodriguez
2017-06-26 21:19 ` Luis R. Rodriguez
2017-06-29 15:14 ` Greg KH
2017-06-29 15:14 ` Greg KH
[not found] ` <20170629151442.GA4880-U8xfFu+wG4EAvxtiuMwx3w@public.gmane.org>
2017-06-29 17:29 ` Luis R. Rodriguez
2017-06-29 17:29 ` Luis R. Rodriguez
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20170614222017.14653-2-mcgrof@kernel.org \
--to=mcgrof@kernel.org \
--cc=alan@linux.intel.com \
--cc=arend.vanspriel@broadcom.com \
--cc=atull@kernel.org \
--cc=dhowells@redhat.com \
--cc=dmitry.torokhov@gmail.com \
--cc=dwmw2@infradead.org \
--cc=ebiederm@xmission.com \
--cc=emmanuel.grumbach@intel.com \
--cc=gregkh@linuxfoundation.org \
--cc=hdegoede@redhat.com \
--cc=jewalt@lgsinnovations.com \
--cc=johannes.berg@intel.com \
--cc=keescook@chromium.org \
--cc=kvalo@codeaurora.org \
--cc=linux-api@vger.kernel.org \
--cc=linux-fsdevel@vger.kernel.org \
--cc=linux-kernel@vger.kernel.org \
--cc=luciano.coelho@intel.com \
--cc=luto@kernel.org \
--cc=mawilcox@microsoft.com \
--cc=mfuzzey@parkeon.com \
--cc=moritz.fischer@ettus.com \
--cc=mtk.manpages@gmail.com \
--cc=mtosatti@redhat.com \
--cc=paul.gortmaker@windriver.com \
--cc=pjones@redhat.com \
--cc=pmladek@suse.com \
--cc=rafal@milecki.pl \
--cc=rjw@rjwysocki.net \
--cc=takahiro.akashi@linaro.org \
--cc=torvalds@linux-foundation.org \
--cc=tytso@mit.edu \
--cc=wagi@monom.org \
--cc=yi1.li@linux.intel.com \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.